<?php

namespace FM\Factory;

use Doctrine\ORM\EntityManager;
use FM\Traits\TQuery;

class ChecklistFactory {
  
    use TQuery;
    
    protected $connection;
    protected $entityManager;
    
    public function __construct(EntityManager $entityManager) {
        
        $this->connection = $entityManager->getConnection();
        $this->entityManager = $entityManager;
    }
  
  public function getChecklist() {
    $sql = "SELECT NRCHECKLIST, NMCHECKLIST,NRTIPOLOCALCLI
              FROM FCM_CHECKLIST";
    $std = $this->connection->prepare($sql);
    $std->execute();
    return $std->fetchAll();
  }
  
  public function getChecklistDatasource() {
    $sql = "SELECT NRCHECKLIST, NMCHECKLIST,NRTIPOLOCALCLI
              FROM FCM_CHECKLIST";
    return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
  }
  
  public function getSpecificChecklist($param) {
    $sql = "SELECT NRCHECKLIST, NMCHECKLIST
              FROM FCM_CHECKLIST
            WHERE NRTIPOLOCALCLI in (".$param['nr'].")";
    $std = $this->connection->prepare($sql);
    $std->execute();
    return $std->fetchAll();
  }
  
  public function listChecklist($params) {
        $useParams = false;
        $sqlCode = "SELECT checklist.NRCHECKLIST, checklist.NMCHECKLIST,
            checklist.DSCHECKLIST, checklist.NRSETOR,
            checklist.NRCRITICIDADECHK, checklist.NRHABILIDADE,
            checklist.IDATIVO, checklist.NRORG, checklist.DTINCLUSAO,
            checklist.CDOPERINCLUSAO, checklist.NRORGINCLUSAO, 
            checklist.DTULTATU, checklist.CDOPERULTATU,
            checklist.NRORGULTATU, checklist.NRTIPOLOCALCLI
            FROM FCM_CHECKLIST checklist";
        $whereClausule =  $this->concatWhereClausule($params);
        if (strlen($whereClausule) > 0) {
            $useParams = true;
            $sqlCode .= $whereClausule;
        }
        $std = $this->connection->prepare($sqlCode);
        if ($useParams) {
            $std->execute($params);   
        } else {
            $std->execute();
        }
        return $std->fetchAll();
    }
    
  private function concatWhereClausule($params) {
      $useParams = false;
      $paramKeys = array_keys($params);
      $query = "";
      foreach($paramKeys as $key) {
          if (!$useParams) {
              $useParams = true;
              $query.= " WHERE ";
          } else {
              $query.= " AND ";
          }
          $query.= $this->alias . "." . $key . " = :" . $key;
      }
      return $query;
  }
}

?>