DROP VIEW ETL_CONTARECEBIDA
/

CREATE VIEW ETL_CONTARECEBIDA AS
SELECT *
  FROM (SELECT /*+ LEADING(BA BO CT CL RV GR TP CC) */
               CT.NRORG, 
               CL.CDCLIENTE,
               CL.NMFANTCLIE, -- DIMENSO 00301 CLIENTE (NOME FANTASIA)
               CL.NMFANTCLIE NMPARCNEGOCIO, -- DIMENSO 00286 PARCEIRO (CLI-FOR)
               CL.NMRAZSOCCLIE,
               NVL(RV.NMFANTCLIE, 'TEKNISA (SEM REVENDA ASSOCIADA)') NMFANTREVENDA, -- DIMENSO 00454 REVENDA (NOME FANTASIA)
               NVL(RV.NMRAZSOCCLIE, 'TEKNISA (SEM REVENDA ASSOCIADA)') NMRAZSOCREVENDA, -- DIMENSO 00455 REVENDA (RAZO SOCIAL)
               CL.DTCADACLIE,
               TO_CHAR(CL.DTCADACLIE, 'YYYY/MM/DD') DSANOMESDIACADA, -- DIMENSO 00436 -ACEITE - DIA
               TO_CHAR(CL.DTCADACLIE, 'YYYY/MM') DSANOMESCADA, -- DIMENSO 00435 ACEITE - MS
               TO_CHAR(CL.DTCADACLIE, 'YYYY') ANCADACLIE, -- DIMENSO 00434 ACEITE - ANO
               GR.CDGRUPCLIE,
               NVL(GR.NMGRUPCLIE, 'NO CADASTRADO') NMGRUPCLIE, -- DIMENSO 00437 GRUPO DE CLIENTE
               CL.CDGERENTECOMERC, -- DIMENSO 00321 GERENTE COMERCIAL (OPERADOR)
               CL.CDAGENTENEGOCIO, -- DIMENSO 00322 AGENTE DE NEGCIOS (OPERADOR)
               CT.CDTPCTRECEB, -- DIMENSO 00271 TIPO DE CONTA RECEBIDA
               'REC-'||TP.DSTPCTRECEB TIPO_CONTA, -- 00279
               LTRIM(SUBSTR(TO_CHAR(SUM(1) OVER (PARTITION BY CL.NMFANTCLIE, CT.CDTPCTRECEB
                                           ORDER BY CL.NMFANTCLIE, CT.CDTPCTRECEB, BA.DTBAIXAREC
                                           ROWS BETWEEN UNBOUNDED PRECEDING AND CURRENT ROW), '99999'), 2, 5)) NRRECEBIMENTO_TIPO_CONTA, -- DIMENSO 00456 N DO RECEBIMENTO
               BA.CDREDUCONT, -- DIMENSO 06000 CONTA CORRENTE
               TO_CHAR(BA.DTBAIXAREC, 'YYYY') DSANO, -- DIMENSO 00025 ANO
               TO_CHAR(BA.DTBAIXAREC, 'YYYY-MM') DSMES, -- DIMENSO 00027 MS
               TO_CHAR(TRUNC((TO_CHAR(BA.DTBAIXAREC, 'MM') - 1) / 2) + 1)||' BIM' DSBIMESTRE, -- DIMENSO 00011 BIMESTRE
               TO_CHAR(TRUNC((TO_CHAR(BA.DTBAIXAREC, 'MM') - 1) / 3) + 1)||' TRI' DSTRIMESTRE, -- DIMENSO 00012 TRIMESTRE
               TO_CHAR(TRUNC((TO_CHAR(BA.DTBAIXAREC, 'MM') - 1) / 6) + 1)||' SEM' DSSEMESTRE, -- DIMENSO 00013 SEMESTRE
               BA.DTBAIXAREC,
               TO_DATE('01'||TO_CHAR(BA.DTBAIXAREC, 'MMYYYY'), 'DDMMYYYY') DTMESBAIXAREC,
               TO_CHAR(BA.DTBAIXAREC, 'YYYY/MM/DD') DSANOMESDIAREC, -- DIMENSO 00433 REC.(BAIXA) - DIA
               TO_CHAR(BA.DTBAIXAREC, 'YYYY/MM') DSANOMESREC, -- DIMENSO 00432 REC.(BAIXA) - MS
               CASE WHEN (TO_CHAR(BA.DTBAIXAREC, 'DD') >= '21') AND (TO_CHAR(BA.DTBAIXAREC, 'DD') <= '31')
                THEN TO_CHAR(TO_DATE('21/'||TO_CHAR(BA.DTBAIXAREC, 'MM/YYYY')), 'YYYY-MM-DD')||' A '||
                     TO_CHAR(ADD_MONTHS(TO_DATE('20/'||TO_CHAR(BA.DTBAIXAREC, 'MM/YYYY')), 1), 'YYYY-MM-DD')
                ELSE TO_CHAR(ADD_MONTHS(TO_DATE('21/'||TO_CHAR(BA.DTBAIXAREC, 'MM/YYYY')), -1), 'YYYY-MM-DD')||' A '||
                     TO_CHAR(TO_DATE('20/'||TO_CHAR(BA.DTBAIXAREC, 'MM/YYYY')), 'YYYY-MM-DD')
                 END AS DSPERIODOREC, -- DIMENSO 00316 PERODO
               TO_CHAR(BA.DTBAIXAREC, 'YYYY') ANBAIXAREC, -- DIMENSO 00431 REC.(BAIXA) - ANO
               BA.NRBAIXAREC,
               BO.CDEMPRESA, -- DIMENSO 00264 EMPRESA
               BA.CDFILIAL,
               BO.NRLANBOLREC,
               BO.DTVENBOLREC,
               BO.CDNOSNUMREC,
               CASE WHEN SUBSTR(CC.DSCONTCORR, 1, 2) = 'AP' THEN 'Aplicao Financeira'
                    WHEN SUBSTR(CC.DSCONTCORR, 1, 2) = 'CC' THEN 'Conta Corrente'
                    ELSE 'Indefinida'
                     END AS DSFINALIDADE_CONTCORR, -- DIMENSO 06001 FINALIDADE DA CONTA
               ROUND(BO.VRBOLREC, 2) BOLETO_VALOR_BRUTO,
               ROUND(BO.VRFINALBREC, 2) BOLETO_VALOR_LIQUIDO,
               ROUND(BO.VRFINALBREC, 2) - ROUND(BO.VRBOLREC, 2) BOLETO_AJUSTE,
               ROUND(CT.VRATUAREC, 2) CONTA_VALOR_INICIAL,
               (BO.VRFINALBREC - BO.VRBOLREC) * (CT.VRATUAREC/BO.VRBOLREC) CONTA_AJUSTE,
               ROUND(CT.VRATUAREC, 2) + ((BO.VRFINALBREC - BO.VRBOLREC) * (CT.VRATUAREC/BO.VRBOLREC)) CONTA_AJUSTADA_RECEBIDA
          FROM CONTCORR CC, TIPOCTRECEBER TP, GRUPCLIE GR, CLIENTE RV, CLIENTE CL, CONTARECEBER CT, BOLETRECEBER BO, BAIXARECEBIDA BA
         WHERE BA.DTBAIXAREC >= TO_DATE('01/01/2011', 'DD/MM/YYYY')
           AND BA.IDSTATUSBREC = 'E'
           AND BO.CDFILIBAIREC = BA.CDFILIAL  
           AND BO.NRBAIXAREC = BA.NRBAIXAREC  
           AND BO.NRORG = BA.NRORG
           AND BO.VRFINALBREC <> 0
           AND CT.CDFILIBOLREC = BO.CDFILIAL
           AND CT.NRLANBOLREC = BO.NRLANBOLREC
           AND CT.NRORG = BO.NRORG
           AND CL.CDCLIENTE = BO.CDCLIENTE
           AND CL.NRORG = BO.NRORG
           AND RV.CDCLIENTE (+) = CL.CDCLIEPRINCIPAL
           AND RV.NRORG (+) = CL.NRORG
           AND GR.CDGRUPCLIE (+) = CL.CDGRUPCLIE
           AND GR.NRORG (+) = CL.NRORG
           AND TP.CDTPCTRECEB = CT.CDTPCTRECEB
           AND TP.NRORG = CT.NRORG
           AND CC.CDREDUCONT = BA.CDREDUCONT
           AND CC.NRORG = BA.NRORG)
/

DROP INDEX BAIXARECEBIDA_01
/

CREATE INDEX BAIXARECEBIDA_01 ON BAIXARECEBIDA (DTBAIXAREC ASC, CDEMPRESA ASC, NRORG ASC)
/
  
-- VERSAO --
BEGIN ATUVEROBJ('ETL_CONTARECEBIDA','0.00.000'); END;
/
