CREATE OR REPLACE FUNCTION CODIGO_PRODUTO_GNRE_RJ(
   P_IDTPDOC   IN PARAMESTGNRE.IDTPGUIA%TYPE, /*D - DARJ, G - GNRE*/
   P_TPRESPONS IN VARCHAR2, /*E - DARJ POR RESPONSABILIDADE (Notas de Entrada), S - DARJ POR OPERAO PRPRIA (Notas de Sada)*/
   P_CDEMPRESA IN PARAMGNRE.CDEMPRESA%TYPE) RETURN VARCHAR2
AS
   V_CDPRODUTODEB  PARAMGNRE.CDPRODUTODEB%TYPE;
   V_CDPRODUTOGNRE PARAMGNRE.CDPRODUTODEB%TYPE;
BEGIN
   V_CDPRODUTODEB := '';

   BEGIN
      SELECT CDPRODUTODEB
        INTO V_CDPRODUTODEB
        FROM PARAMGNRE
       WHERE CDEMPRESA = P_CDEMPRESA;
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_CDPRODUTODEB := '';
   END;

   IF P_IDTPDOC = 'D' THEN  /*DARJ*/
      IF P_TPRESPONS = 'S' THEN /*POR OPERAO PRPRIA*/
         CASE V_CDPRODUTODEB
            WHEN '00001' THEN V_CDPRODUTOGNRE := '108';
            WHEN '00002' THEN V_CDPRODUTOGNRE := '116';
            WHEN '00003' THEN V_CDPRODUTOGNRE := '124';
            WHEN '00004' THEN V_CDPRODUTOGNRE := '132';
            WHEN '00005' THEN V_CDPRODUTOGNRE := '140';
            WHEN '00006' THEN V_CDPRODUTOGNRE := '159';
            WHEN '00007' THEN V_CDPRODUTOGNRE := '167';
            WHEN '00008' THEN V_CDPRODUTOGNRE := '175';
            WHEN '00009' THEN V_CDPRODUTOGNRE := '183';
            WHEN '00010' THEN V_CDPRODUTOGNRE := '191';
            WHEN '00011' THEN V_CDPRODUTOGNRE := '205';
            WHEN '00012' THEN V_CDPRODUTOGNRE := '396';
            ELSE V_CDPRODUTOGNRE := '';
         END CASE;
      ELSE
         IF P_TPRESPONS = 'E' THEN  /*POR RESPONSABILIDADE*/
            CASE V_CDPRODUTODEB
               WHEN '00001' THEN V_CDPRODUTOGNRE := '400';
               WHEN '00002' THEN V_CDPRODUTOGNRE := '418';
               WHEN '00003' THEN V_CDPRODUTOGNRE := '426';
               WHEN '00004' THEN V_CDPRODUTOGNRE := '434';
               WHEN '00005' THEN V_CDPRODUTOGNRE := '442';
               WHEN '00006' THEN V_CDPRODUTOGNRE := '450';
               WHEN '00007' THEN V_CDPRODUTOGNRE := '469';
               WHEN '00008' THEN V_CDPRODUTOGNRE := '477';
               WHEN '00009' THEN V_CDPRODUTOGNRE := '485';
               WHEN '00010' THEN V_CDPRODUTOGNRE := '493';
               WHEN '00011' THEN V_CDPRODUTOGNRE := '507';
               WHEN '00012' THEN V_CDPRODUTOGNRE := '698';
               ELSE V_CDPRODUTOGNRE := '';
            END CASE;
         END IF;
      END IF;
   ELSE
      IF P_IDTPDOC = 'G' THEN /*GNRE*/
         CASE V_CDPRODUTODEB
            WHEN '00001' THEN V_CDPRODUTOGNRE := '400';
            WHEN '00002' THEN V_CDPRODUTOGNRE := '418';
            WHEN '00003' THEN V_CDPRODUTOGNRE := '426';
            WHEN '00004' THEN V_CDPRODUTOGNRE := '434';
            WHEN '00005' THEN V_CDPRODUTOGNRE := '442';
            WHEN '00006' THEN V_CDPRODUTOGNRE := '450';
            WHEN '00007' THEN V_CDPRODUTOGNRE := '469';
            WHEN '00008' THEN V_CDPRODUTOGNRE := '477';
            WHEN '00009' THEN V_CDPRODUTOGNRE := '485';
            WHEN '00010' THEN V_CDPRODUTOGNRE := '493';
            WHEN '00011' THEN V_CDPRODUTOGNRE := '507';
            WHEN '00012' THEN V_CDPRODUTOGNRE := '698';
            ELSE V_CDPRODUTOGNRE := '';
         END CASE;
      END IF;
   END IF;
   RETURN(V_CDPRODUTOGNRE);
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('CODIGO_PRODUTO_GNRE_RJ','5.67.000'); END;
/

