/* eslint-disable */
import { IDictionary, Http, Metadata, IEventParam, Loader, SimpleDatasource, } from '@zeedhi/core';
import {
    Text, Textarea, Col, CheckboxMultiple, Button,
    Form, FileInput, Modal, ModalService, LoadingService,
} from '@zeedhi/common';
import FileUpload from '../FileUpload';
import { Utilities } from '@/util/Utilities';
import { IterableCarousel, TekGrid, TekTreeGrid } from '@zeedhi/teknisa-components-common';

export class Fm00005000VistoriasController {
    public hierarquiasController = Loader.getInstance('HierarquiasController');

    public visibilidade: boolean = true;

    public currentRow: any = {};

    public nomeVistoria: String = '';

    public nrfoto: String = '';

    private modalVisualizar!: Modal;

    private modalAnexo!: Modal;

    private modalInfoDetalhes!: Modal;

    private modalExibirImagens!: Modal;

    public NRGERENCIAMENTOCHK: any = '';

    // Controle dos modais e visibilidade 
    public async modalVisualizarDados({ row }: any) {
        this.modalVisualizar = await ModalService.createFromJson('/fm_00005_000_vistorias/modal/fm_00005_001_vistorias_detalhes', true);
        this.modalVisualizar.show();
        this.currentRow = row;
    }

    public async fecharModalVisualizarDados() {
        await this.modalVisualizar.hide();
        this.modalVisualizar.destroy();
    }

    public async abrirModalAnexo() {
        this.modalAnexo = await ModalService.createFromJson('/fm_00005_000_vistorias/modal/fm_00005_002_modal_abrir_anexo', true);
        this.modalAnexo.show();
    }

    public async fecharModalAnexo() {
        await this.modalAnexo.hide();
        this.modalAnexo.destroy();
    }

    public async abrirModalExibirImagens() {
        this.modalExibirImagens = await ModalService.createFromJson('/fm_00005_000_vistorias/modal/fm_00005_004_exibir_imagens_anexo', true);
        this.modalExibirImagens.show();
    }

    public async fecharModalExibirImagens() {
        await this.modalExibirImagens.hide();
        this.modalExibirImagens.destroy();
    }

    public async abrirModalInfoDetalhes() {
        this.modalInfoDetalhes = await ModalService.createFromJson('/fm_00005_000_vistorias/modal/fm_00005_003_exibir_info_detalhes', true);
        this.modalInfoDetalhes.show();
    }

    public async fecharModalInfoDetalhes() {
        await this.modalInfoDetalhes.hide();
        this.modalInfoDetalhes.destroy();
    }

    public async abrirModalAnexarImagens() {
        this.modalInfoDetalhes = await ModalService.createFromJson('/fm_00005_000_vistorias/modal/fm_00005_005_anexar_imagens', true);
        this.modalInfoDetalhes.show();
    }

    public async fecharModalAnexarImagens() {
        await this.modalInfoDetalhes.hide();
        this.modalInfoDetalhes.destroy();
    }

    public invisivel({ component }: any) {
        component.isVisible = false;
    }

    public visualizarDadosGerais({ row }: any) {
        this.visibilidade = false;
        this.currentRow = row;
        this.NRGERENCIAMENTOCHK = row.NRGERENCIAMENTOCHK;
    }

    public exibirImagem({ component }: any) {
        const carrosel = Metadata.getInstance<IterableCarousel>(component.name.split('_')[1]);
        const row = Metadata.getInstance<Col>('LinhaCarrosel');
        const imagens: any = [];
        if (component.value.length) {
            row.isVisible = true;
            component.value.forEach((imagem: any, pos: number) => {
                imagens.push({
                    id: `cliente_${pos}`,
                    src: window.URL.createObjectURL(imagem),
                });
            });
        } else {
            row.isVisible = false;
        }
        carrosel.iterable.datasource.updateData(imagens);
    }

    // ---------- Validações e filtros ----------
    public setFiltroModal({ component }: IEventParam<TekTreeGrid>) {
        component.datasource.setFilter({
            NRGERENCIAMENTOCHK: this.currentRow.NRGERENCIAMENTOCHK,
        });
    }

    public tituloPagina({ component }: any) {
        const tituloModal = this.currentRow.NMGERENCIAMENTOCHK;
        return component.text = tituloModal;
    }


    public linhaEditavel({ row }: IDictionary<any>) {
        return (row.TIPO !== 'Critério' ? false : true);
    }

    public mudaCor({ row }: IDictionary<any>) {
        if (row.IDMARCADO === 'N') {
            return { 'color': 'rgb(255, 0, 0)' };
        }
    }

    public validaObservacoes({ component }: any) {
        if (this.currentRow.IDOBRIGAOBSERVACAO !== 'S') {
            component.clearValidations();
        }
    }

    public setFiltro({ component }: any) {
        component.datasource.dynamicFilter = {
            IDATIVO: [{
                relation: 'AND',
                operation: 'IN',
                value: 'S',
            }],
        };
        component.datasource.get();
    }

    // ---------- Requisições de get e post ----------
    public async salvaCriterios({ component }: any) {
        event?.preventDefault();
        const form = Metadata.getInstance<Form>('formObservacao');
        const treeGrid = Metadata.getInstance<TekTreeGrid>('tree-grid-vistoria');
        const grid = Metadata.getInstance<TekGrid>("tek-grid-vistorias");
        const btnSalvar = component.name === 'salvarVistoriaDetalhes'; // Variável para saber se foi clicado através do botão de baixo "Salvar".
        if (this.currentRow.IDSITUACAOAGEND !== '1') {
            if (!btnSalvar || (Utilities.validateForm(form) && btnSalvar && !treeGrid.editing)) {
                LoadingService.show();
                Http.post('/updateInspection', {
                    DRG: (btnSalvar) ? Metadata.getInstance<Textarea>('campoObservacoes').value : component.getEditedRows(),
                    finalizar: btnSalvar,
                    NR: this.currentRow.NRGERENCIAMENTOCHK,
                }).then(() => {
                    if (!btnSalvar) component.datasource.get();
                    Utilities.showSuccessMessage();
                }).catch((error: any) => {
                    Utilities.showErrorMessage(error);
                }).finally(() => {
                    if (!btnSalvar) {
                        component.cancelEditedRows();
                        grid.datasource.get();
                    }
                    LoadingService.hide();
                    if (btnSalvar) {
                        this.fecharModalVisualizarDados();
                        grid.datasource.get();
                    }
                });
            } else if (treeGrid.editing) {
                Utilities.messages('Erro!', "Conclua as alterações dos critérios antes de salvar.");
            }
        } else {
            Utilities.messages('Erro!', "Tarefa ainda não finalizada, aguarde a conclusão para realizar vistoria.");
            if (!btnSalvar) component.cancelEditedRows();
        }
    }

    public carregarFotos({ component }: any) {
        const nr = this.currentRow.NRGERENCIAMENTOCHK;
        this.nrfoto = component.iterable.datasource.data;
        LoadingService.show();
        Http.post('/getFotosVistoria', {
            NRGERENCIAMENTOCHK: nr,
        }).then((response: any) => {
            if (response.data.data.length === 0) {
                component.isVisible = false;
                Metadata.getInstance<Text>('sem-resultado-imagens-vistorias').isVisible = true;
            } else {
                response.data.data.forEach((dados: IDictionary) => {
                    component.iterable.datasource.data.push({
                        NRFOTOTAREFAGERCHK: dados.NRFOTOTAREFAGERCHK,
                        DSFOTOTAREFAGERCHK: dados.DSFOTOTAREFAGERCHK,
                    });
                });
                Metadata.getInstance<Button>('Btn-DeleteImage').isVisible = true;
            }
        }).catch((error: any) => {
            Utilities.showErrorMessage(error);
        }).finally(() => {
            LoadingService.hide();
        });
    }

    public carregarFotosTarefa({ component }: any) {
        const nr = this.currentRow.NRCHECKLISTAGEND;

        LoadingService.show();
        Http.post('/getFotosTarefas', {
            NRCHECKLISTAGEND: nr
        }).then((response: any) => {
            if (response.data.data.length === 0) {
                component.isVisible = false;
                Metadata.getInstance<Text>('sem-resultado-imagens-tarefas').isVisible = true;
            } else {
                response.data.data.forEach((dados: IDictionary) => {
                    component.iterable.datasource.data.push({
                        NRFOTOTAREFAAGEND: dados.NRFOTOTAREFAAGEND,
                        DSFOTOTAREFAAGEND: dados.DSFOTOTAREFAAGEND,
                    });
                });
            }
        }).catch((error: any) => {
            Utilities.showErrorMessage(error);
        }).finally(() => {
            LoadingService.hide();
        });
    }

    // Seta as informações no modal Info Detelhes
    public montarInformacoesComplementares() {
        LoadingService.show();
        const nr = this.currentRow.NRCHECKLISTAGEND;
        const checkbox = Metadata.getInstance<CheckboxMultiple>('checkbox-itens');
        const observacoes = Metadata.getInstance<Textarea>('observacoes-tarefas');
        const semItens = Metadata.getInstance<Text>('nao-ha-itens');
        let mensagem = ''

        Http.post('/getItensTarefas', {
            NRCHECKLISTAGEND: nr,
        }).then((response: IDictionary) => {
            const dados = response.data.data;

            checkbox.value = dados.filter((elemento: any) => elemento.IDREALIZADO === 'S').map((elemento: any) => elemento.NMTAREFA);
            (checkbox.datasource as SimpleDatasource)!.items = dados.map((elemento: any) => elemento.NMTAREFA);

            if (dados.length > 0) {
                semItens.isVisible = false;
            } else {
                semItens.isVisible = true;
            }

            if (this.currentRow.DSJUSTCANCELAMENTO !== null && dados.DSOBSTAREFAAGEND !== undefined) {
                mensagem = `Justificativa de cancelamento: ${this.currentRow.DSJUSTCANCELAMENTO} - Observações da Tarefa: ${dados.DSOBSTAREFAAGEND}`;
            } else if (this.currentRow.DSJUSTCANCELAMENTO !== null) {
                mensagem = `Justificativa de cancelamento: ${this.currentRow.DSJUSTCANCELAMENTO}`;
            } else if (dados.DSOBSTAREFAAGEND !== undefined) {
                mensagem = `Observações da Tarefa: ${dados.DSOBSTAREFAAGEND}`;
            } else {
                mensagem = "Não há observações";
            }
            observacoes.value = mensagem;
        }).catch((error: any) => {
            Utilities.showErrorMessage(error);
        }).finally(() => {
            LoadingService.hide();
        });
    }

    public async anexarImage() {
        const imagensConvertidas = await FileUpload.converterImagens('FileInput-ImagensDoAtivo_carouselImagesAnexoTask');
        if (imagensConvertidas.length > 0) {
            LoadingService.show('Salvando...');
            Http.post('/anexarFotoVistoria', {
                IMAGEM: imagensConvertidas,
                NRTAREFA: this.currentRow.NRGERENCIAMENTOCHK,
            }).then((response: any) => {
                LoadingService.hide();
                if (response.data === 'success') {
                    const file = Metadata.getInstance<FileInput>('FileInput-ImagensDoAtivo_carouselImagesAnexoTask');
                    file.value = [];
                    this.exibirImagem({ component: file });
                    Utilities.messages('OK', 'Imagens anexadas com sucesso!');
                } else {
                    Utilities.messages('Error', 'Ocorreu um erro ao salvar as imagens.<br>.Tente novamente.<br><br>Se o problema persistir entre em contato com o suporte.');
                }
            });
        }
    }

    public async deletImage() {
        const id = this.currentRow.NRGERENCIAMENTOCHK;
        LoadingService.show('Deletando...');
        const carrosel = Metadata.getInstance<IterableCarousel>('carousel-imagens-anexo-vistorias');
        const img = carrosel.iterable.datasource.data;
        const [deleteData] = img.filter((value: any, index: any) => { return index === carrosel.currentSlide; });
        Http.get(`/deleteFotoVistoria?NRTAREFA=${id}&&NRFOTOTAREFA=${deleteData.NRFOTOTAREFAGERCHK}`).then((response: any) => {
            LoadingService.hide();
            if (response.data === 'success') {
                const newData = img.filter((imagem: any, index: any) => { return index !== carrosel.currentSlide; });
                carrosel.iterable.datasource.updateData(newData);

                if (newData.length === 0) {
                    Metadata.getInstance<Button>('Btn-DeleteImage').isVisible = false;
                    Metadata.getInstance<Text>('sem-resultado-imagens-vistorias').isVisible = true;
                }
            }
        });
    }

}
